#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <values.h>
#include <string.h>
#include <unistd.h>
#include "error.h"
#include <float.h>


#define round(X) floor((X)+.5)


float avgf(float *t,int l){
  int i;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    sum+=t[i];
  return sum/l;
}

float avgint(int *t,int l){
  int i;
  float sum=0.0;
  if (l==0) return 0.0;

  for (i=0;i<l;i++)
    sum+=((float)t[i]);
  return sum/l;
}


/* average when index ind is excludes */
float exceptavgf(float *t,int l,int ind){
  int i;
  float sum=0.0;

  if ((l==1)||(l==0)) return 0.0; 
  for (i=0;i<l;i++){
    if (i!=ind)
      sum+=t[i];
  }

  return sum/(l-1);
}


/* suodattaa pois arvot, jotka <minth, jalj=jaljellee jaaneiden lkm */
float filteravgf(float *t,int l, int *jalj,float minth){
  int i;
  float sum=0.0;

  if (l==0){
    (*jalj)=0; 
    return 0.0;
  }
  (*jalj)=0;
  for (i=0;i<l;i++){
    if (t[i]>=minth){
      sum+=t[i];
      (*jalj)++;
    }
  }

  if ((*jalj)>0)
    return sum/(*jalj);
  else return 0.0;
}


/* sama mutta indeksi ind jatetaan huomiotta */
float exceptfilteravgf(float *t,int l, int *jalj,float minth, int ind){
  int i;
  float sum=0.0;

  if (l==0) return 0.0;
  (*jalj)=0;
  for (i=0;i<l;i++){
    if (((i!=ind)&&t[i]>=minth)){
      sum+=t[i];
      (*jalj)++;
    }
  }

  if ((*jalj)>0)
    return sum/(*jalj);
  else return 0.0;
}



float stdevf(float *t,int l,float avgx){
  int i;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    sum+=pow((t[i]-avgx),2);
  return sqrt(sum/l);
}

/* suodattaa pois arvot, jotka <minth */
float filterstdevf(float *t,int l,float avgx, float minth){
  int i,jalj=0;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    if (t[i]>=minth){
    sum+=pow((t[i]-avgx),2);
    jalj++;
  }
  if (jalj>0)
    return sqrt(sum/jalj);
  else return 0.0;
}

/* sama mutta indeksi ind jatetaan huomiotta */
float exceptfilterstdevf(float *t,int l,float avgx, float minth, int ind){
  int i,jalj=0;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    if ((i!=ind)&&(t[i]>=minth)){
    sum+=pow((t[i]-avgx),2);
    jalj++;
  }
  if (jalj>0)
    return sqrt(sum/jalj);
  else return 0.0;
}



float exceptstdevf(float *t,int l,float avgx, int ind){
  int i,jalj=0;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    if ((i!=ind)){
    sum+=pow((t[i]-avgx),2);
    jalj++;
  }
  if (jalj>0)
    return sqrt(sum/jalj);
  else return 0.0;
}


float kurtosisf(float *t, int l, float avgx, float stdevx){
  int i;
  float sum=0.0;
  /* erikoistapaus, jos stdev=0 */
  if (stdevx<=0.00001)
    return 0.0;
  
  for (i=0;i<l;i++)
    sum+=pow(t[i]-avgx,4);

  return (sum/(l*pow(stdevx,4))-3.0);
}

float skewf(float *t, int l, float avgx, float stdevx){
  int i;
  float sum=0.0;
  /* erikoistapaus, jos stdev=0 */
  if (stdevx<=0.00001)
    return 0.0;
  
  for (i=0;i<l;i++)
    sum+=pow(t[i]-avgx,3);

  return (sum/(l*pow(stdevx,3)));
}




double maxd(double *t,int l){
  double m=-1*(DBL_MAX-1);
  int i;
  for (i=0;i<l;i++)
    if (t[i]>m) m=t[i];

  return m;
}



float maxf(float *t,int l){
  float m=-1*(FLT_MAX-1);
  int i;
  for (i=0;i<l;i++)
    if (t[i]>m) m=t[i];

  return m;
}

float maxfjasij(float *t,int size, int *sij){
  float m=-1*(FLT_MAX-1);
  int i;
  for (i=0;i<size;i++)
    if (t[i]>m){ 
      m=t[i];
      (*sij)=i;
    }

  return m;
}

float minfjasij(float *t,int size, int *sij){
  float m=FLT_MAX;
  int i;
  for (i=0;i<size;i++)
    if (t[i]<m){ 
      m=t[i];
      (*sij)=i;
    }

  return m;
}




/* search l:th maximum value  */
float lthmaxfjasij(float *t,int size, int l, int *sij){
  float m=-1*(FLT_MAX-1);
  int i,j,ind=-1;
  float *tmp;

  if ((tmp=(float*)malloc(size*sizeof(float)))==NULL)
    error(6);
  for (i=0;i<size;i++)
    tmp[i]=t[i];

  for (j=0;j<l;j++){
    m=-1*(FLT_MAX-1);
    if (ind>-1) /* poista ed. kierroksen maksimi */
      tmp[ind]=-1*(FLT_MAX-1);
    for (i=0;i<size;i++)
      if (tmp[i]>m){ 
	m=tmp[i];
	ind=i;
      }
  }
  (*sij)=ind;
  return m;
}


/* luo jarjestetty kopio annetusta int-taulusta */
int *sort(int *t, int size){
  int min,sij,apu;
  int i,next=0;
  int *tmp;

  if ((tmp=(int*)malloc(size*sizeof(int)))==NULL)
    error(6);
  for (i=0;i<size;i++)
    tmp[i]=t[i];
  while (next<size-1){
    min=tmp[next]; sij=next;
    for (i=next+1;i<size;i++){
      if (tmp[i]<min){
	min=tmp[i];
	sij=i;
      }
    } /* for */
    /* nyt swappaa */
    apu=tmp[next];
    tmp[next]=min;
    tmp[sij]=apu;
    next++;
  }
  return tmp;
}

/* ei ihan oikea maar. poistaa myos duplikaatit */
/* etsi int-taulun mediaani eli keskimmainen arvo */
/* lisaa tilanvap! */
int omamedian(int *t, int size){
  int *tmp;
  int min=0; int max=size-1; /* eka ja viim. indeksi */

  /* erikoistapaus */
  if (size==0)
    return 0; /* onko jarkevaa? pitaisi olla erikseen virhekoodi */

  /* ensin jarjestetty kopio t:sta */
  tmp=sort(t,size);
  
  while (min<max){
    if (tmp[min]==tmp[max]) /* sama arvo */
      return tmp[min]; 
    /* "poista" pienin ja sen duplikaatit alusta */
    while (tmp[min]==tmp[min+1])
      min++;
    /* siirra indeksi seuraavaan, jossa jo eri arvo */
    min++;
    if (tmp[min]==tmp[max]) /* sama arvo */
      return tmp[min]; 
    /* "poista" suurin ja sen duplikaatit lopusta */
    while (tmp[max]==tmp[max-1])
      max--;
    /* siirra indeksi edellisee, jossa jo eri arvo */
    max--;
    /* jos menivat samoiksi, selviaa seuraavan while alussa */
  }

  /* nyt samat */
  return tmp[min];
}


/* kuten ed, mutta mutta t tyyppia float; ovat silti kok.lukuja */
/* jos eivat ole, niin pyoristaa! */
int *sort2(float *t, int size){
  int min,sij,apu;
  int i,next=0;
  int *tmp;

  if ((tmp=(int*)malloc(size*sizeof(int)))==NULL)
    error(6);
  for (i=0;i<size;i++)
    tmp[i]=round(t[i]);
  while (next<size-1){
    min=tmp[next]; sij=next;
    for (i=next+1;i<size;i++){
      if (tmp[i]<min){
	min=tmp[i];
	sij=i;
      }
    } /* for */
    /* nyt swappaa */
    apu=tmp[next];
    tmp[next]=min;
    tmp[sij]=apu;
    next++;
  }
  return tmp;
}


/* sort kun aitoja floateja */
float *sortf(float *t, int size){
  float min,apu;
  int i,sij,next=0;
  float *tmp;

  if ((tmp=(float*)malloc(size*sizeof(float)))==NULL)
    error(6);
  for (i=0;i<size;i++)
    tmp[i]=t[i];
  while (next<size-1){
    min=tmp[next]; sij=next;
    for (i=next+1;i<size;i++){
      if (tmp[i]<min){
	min=tmp[i];
	sij=i;
      }
    } /* for */
    /* nyt swappaa */
    apu=tmp[next];
    tmp[next]=min;
    tmp[sij]=apu;
    next++;
  }
  return tmp;
}


/* kuten ed., mutta t tyyppia float; ovat silti kok.lukuja */
/* lisaa tilanvap! */
int omamedian2(float *t, int size){
  int *tmp;
  int min=0; int max=size-1; /* eka ja viim. indeksi */

  /* erikoistapaus */
  if (size==0)
    return 0; /* onko jarkevaa? pitaisi olla erikseen virhekoodi */

  /* ensin jarjestetty kopio t:sta */
  tmp=sort2(t,size);
  
  while (min<max){
    if (tmp[min]==tmp[max]) /* sama arvo */
      return tmp[min]; 
    /* "poista" pienin ja sen duplikaatit alusta */
    while (tmp[min]==tmp[min+1])
      min++;
    /* siirra indeksi seuraavaan, jossa jo eri arvo */
    min++;
    if (tmp[min]==tmp[max]) /* sama arvo */
      return tmp[min]; 
    /* "poista" suurin ja sen duplikaatit lopusta */
    while (tmp[max]==tmp[max-1])
      max--;
    /* siirra indeksi edellisee, jossa jo eri arvo */
    max--;
    /* jos menivat samoiksi, selviaa seuraavan while alussa */
  }

  /* nyt samat */
  return tmp[min];
}


/* kuten ed. mutta oikea mediaani! */
int median2(float *t, int size){
  int *tmp;
  int med;

  /* erikoistapaus */
  if (size==0)
    return 0; /* onko jarkevaa? pitaisi olla erikseen virhekoodi */

  /* ensin jarjestetty kopio t:sta */
  tmp=sort2(t,size);
  
  /* jos pariton koko, niin keskimm. arvo, muuten pienempi keskimmaisista */
  if (size%2==0)
    med=tmp[size/2-1];
  else med=tmp[(size+1)/2-1];

  free(tmp);
  return med;
}



/* mediaani kun oikeasti floateja */
float medianf(float *t, int size){
  float *tmp;
  float med;

  /* erikoistapaus */
  if (size==0)
    return 0; /* onko jarkevaa? pitaisi olla erikseen virhekoodi */

  /* ensin jarjestetty kopio t:sta */
  tmp=sortf(t,size);
  
  /* jos pariton koko, niin keskimm. arvo, muuten keskiarvo */
  if (size%2==0)
    med=tmp[(size+1)/2-1];
  else med=(tmp[size/2-1]+tmp[size/2])/2.0;

  free(tmp);
  return med;
}

/* poikkeamien nelioiden mediaanin neliojuuri, mediaanivastine stdeville */
float meddevf(float *t, int size,float med){
  float *tmp;
  float meddev=0.0;
  int i;

  if ((tmp=(float*)malloc(size*sizeof(float)))==NULL)
    error(6);
  /* aputauluun neliopoikkeamat mediaanista */
  for (i=0;i<size;i++)
    tmp[i]=pow(t[i]-med,2);
  /* naiden mediaani */
  meddev=medianf(tmp,size);
  free(tmp);
  /* palauta meddevin neliojuuri */
  return sqrt(meddev);
}


double mind(double *t,int l){
  double m=DBL_MAX;
  int i;
  for (i=0;i<l;i++)
    if (t[i]<m) m=t[i];

  return m;
}


float minf(float *t,int l){
  float m=FLT_MAX;
  int i;
  for (i=0;i<l;i++)
    if (t[i]<m) m=t[i];

  return m;
}


/* Pearsonin korrelaatiokerroin */
float corr(float *x, float *y, float mux, float stdevx, float muy, float stdevy, int n){
  float sum=0.0;
  int i;

  /* erikoistapaus jos stdev==0 */
  if ((stdevx<=0.0000001)||(stdevy<=0.0000001))
    {
      if ((stdevx<=0.0000001)&&(stdevy<=0.0000001))
	return 1.0;
      else return 0.0; /* ei ehka ok? */
    }


  for (i=0;i<n;i++)
    sum+=(x[i]-mux)*(y[i]-muy);
  return sum/(n*stdevx*stdevy);

}



/* 1-arvojen osuus kaikista */
float osuusd(double *t,int l){
  int lkm=0;
  int i;
  for (i=0;i<l;i++)
    if (t[i]>0.0) lkm++;

  return ((float)lkm)/l;
}


/* taulukon 1. indeksi jossa arvo >=0; -1 jos ei loydy */
 int ekaarvof(float *t,int l){
   int i;
   for (i=0;i<l;i++)
     if (t[i]>=0) break;

   if (i<l-1) return i;
   else{ 
     if (t[l-1]>=0) return l-1;
     else return -1; 
   }
 }


/* palauttaa viimeisen indeksin jossa arvo >-FLT_MAX ja -1 jos ei lydy */
int vikaarvof(float *t, int l){
  int i;

  for (i=l-1;i>=0;i--)
    if (t[i]>-1.0*FLT_MAX) break;

  if (i>0) return i;
  /* jos tuli taulukon alkuun */
  if (t[0]>-1.0*FLT_MAX) return 0;
  else return -1;
}



/* laskee rivien lkm:n tiedostossa */
int nofrows(FILE *f){
  int lkm=0;
  char *row;
  int LLEN=20000;

  if ((row=(char*)malloc(LLEN))==NULL) error(6);

  while (fgets(row, LLEN, f)!=NULL)
      lkm++;

  rewind(f);

  return lkm;
}

/* tarkista ettei taulussa nan:eja tai infeja; jos ok, palauta 1 */
int tarkistataulu(float *t, int size){
  int i;

  for (i=0;i<size;i++)
    if (isfinite(t[i])==0){
      printf("Virheellinen lukuarvo positiossa %d (nan tai inf)\n",i);
      return 0;
    }

  return 1;
}


/* siirtaa arvot -FLT_MAX loppuun ja palauttaa niiden lkm joissa oikea arvo */
int siirrapuuttuvat(float *t, int l){
  int i, ind;
  int viim=l;

  for (i=0;i<l;i++)
    if (t[i]<=-1.0*FLT_MAX){
      ind=vikaarvof(t,viim);
      if ((ind<=0)||(ind<i)) /* ei en siirtmist */
	break;
      else {
	t[i]=t[ind];
	t[ind]=-1.0*FLT_MAX;
	viim=ind;
      }
    }

  return i;
}



/* luo uuden taulukon, johon sijoittaa normalisoidut arvot */
float *normalisoi(float *t,int l){
  float ka, khaj;
  int i;
  float *ut;

  if ((ut=(float*)malloc(l*sizeof(float)))==NULL) error(6);

  ka=avgf(t,l);
  khaj=stdevf(t,l,ka);
  if (khaj==0.0) 
    for (i=0;i<l;i++)
      ut[i]=0.0;
  else 
    for (i=0;i<l;i++)
      ut[i]=(t[i]-ka)/khaj;

  return ut;
}

float sumf(float *t, int l){
  float sum=0.0;
  int i;
  for (i=0;i<l;i++)
    sum+=t[i];
  return sum;
}

/* moniko ylitt raja-arvon thr? */
int aktlkm(float *t, int l, float thr){
  int i;
  int lkm=0;
  for (i=0;i<l;i++)
    if (t[i]>=thr)
      lkm++;
  return lkm;
}




void printvector(float *t,int l){
  int i;

  for (i=0;i<l;i++)
    printf("%.2f ",t[i]);
  printf("\n");
}

void printvector2(float *t,int l){
  int i;

  if (l>0)
    printf("%.2f",t[0]);
  for (i=1;i<l;i++)
    printf(",%.2f",t[i]);
}



void printtable(float **t, int riv, int sar){
  int i,j;

  for (i=0;i<riv;i++){
    printf("%d ",i);
    for (j=0;j<sar;j++)
      printf("%.2f ",t[i][j]);
    printf("\n");
  }
}


void printinttable(int **t, int riv, int sar){
  int i,j;

  for (i=0;i<riv;i++){
    printf("%d ",i);
    for (j=0;j<sar;j++)
      printf("%d ",t[i][j]);
    printf("\n");
  }
}

/* tulosta ne rivit joilla attr l arvo > thr */
void selprinttable(float **t, int riv, int sar, int l, float thr){
  int i,j;

  for (i=0;i<riv;i++){
    if (t[i][l]>thr){
      printf("%d ",i);
      for (j=0;j<sar;j++)
	printf("%.2f ",t[i][j]);
      printf("\n");
    }
  }
}


void detrange(float *table,int size){
  int i;
  float min;
  float max;

  if (size<1) return;
  min=table[0];  max=table[0]; 
  for (i=0;i<size;i++){
    if (table[i]<min)
      min=table[i];
  if (table[i]>max)
      max=table[i];
  }
  printf("min=%.2f max=%.2f\n",min,max);

}

