#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include "error.h"
#include "apufunktiot.h"
/* Muuntaa attr nimet koodeiksi tai painvastoin. Oletus: kun luodaan uutta */
/* on tiedostossa vain attrnimia. Kun muunnetaan valmiilla taululla, saa */
/* olla muutakin, mutta niita ei muunneta. */
/* syntaksi: namescodes -(n tai c)<syotetdsto> -t<kooditaulun tdsto> [-L] */
/* missa -n kertoo syotteen sis. nimia ja -c koodeja. */
/* Jos -L, luo uuden kooditaulun, muuten kayttaa vanhaa. */

void luoKoodit(FILE *f1,FILE *f2,FILE *f3);
int etsikoodi(char **t,int clkm,char *seur);
int lisaakoodi(char ***t,int *clkm,char *seur, int *size);
char **kasvatataulua(char **t,int *size);
void muunnanimet(FILE *f1,FILE *f2,FILE *f3);
void muunnakoodit(FILE *f1,FILE *f2,FILE *f3);
char **luekoodit(FILE *f,int *clkm);
int kokluku(char *s,int *v);

int main(int argc,char**argv){
  FILE *f1=NULL;FILE *f2=NULL;FILE *f3=NULL;
  int nimia=0;
  int luo=0;
  char *fnimi1=NULL;
  char *fnimi2=NULL;
  char *fnimi3=NULL;
  int opt;

  if (argc<3)
    error(0);

 while ((opt=getopt(argc,argv,"t:n:c:L"))!=-1){
    switch(opt){
    case 't': printf("Kooditaulun tdsto %s\n",optarg);
      fnimi2=(char*)malloc((strlen(optarg)+1)*sizeof(char));
      strcpy(fnimi2,optarg);
      break;
    case 'n': printf("Nimia sis. syotetiedosto %s\n",optarg);
      nimia=1; fnimi1=(char*)malloc((strlen(optarg)+1)*sizeof(char));
      strcpy(fnimi1,optarg);
      if ((f1=fopen(optarg,"r"))==NULL)
	error(1);     
      break;
    case 'c': printf("Koodeja sis. syotetiedosto %s\n",optarg);
      nimia=0; /* ol.arvo */ 
      fnimi1=(char*)malloc((strlen(optarg)+1)*sizeof(char));
      strcpy(fnimi1,optarg);
      if ((f1=fopen(optarg,"r"))==NULL)
	error(1);     
      break;
    case 'L': printf("Luodaan uusi kooditiedosto\n");
      luo=1;
      break;
    default: 
      printf("Unknown option %s\n",optarg);
      error(0);
    }
 }

 if ((luo)&&(nimia==0)){
   printf("Jos luodaan uusi kooditaulu, oltava nimia.\n");
   error(0);
 }

 /* muunnetulle syotetiedostolle uusi tiedosto, jonka paate kertoo tyypin */
 fnimi3=malloc((strlen(fnimi1)+7)*sizeof(char));
 if (nimia)
   sprintf(fnimi3,"%s.codes",fnimi1);
 else sprintf(fnimi3,"%s.names",fnimi1);
 printf("Tulostiedosto %s\n",fnimi3);
 if ((f3=fopen(fnimi3,"w"))==NULL)
   error(1);     

 /* nyt "luo" merkitsee etta on nimia */
 if (luo){ 
   if ((f2=fopen(fnimi2,"w"))==NULL)
     error(1);        
   luoKoodit(f1,f2,f3);
 }
 else {
   if ((f2=fopen(fnimi2,"r"))==NULL)
     error(1);        
   if (nimia)
     muunnanimet(f1,f2,f3);
   else muunnakoodit(f1,f2,f3);
 }

 if(fclose(f1)==EOF)
    error(4);
 if(fclose(f2)==EOF)
    error(4);
 if(fclose(f3)==EOF)
    error(4);

 return EXIT_SUCCESS;
}


/* Lukee tiedostosta f1 nimia. Jos on jo taulussa, muunna ja tulosta f3:een. */
/* Muuten luo uusi koodi tauluun ja tulosta f3:een. Lopuksi kirjoita */ 
/* kooditaulu f2:een. */
void luoKoodit(FILE *f1,FILE *f2,FILE *f3){
  char **koodit;
  int size,next, clkm,code,n,i;
  char *row,*seur;
  int LLEN=50000;

  n=nofrows(f1); /* syotetiedoston koko */
  /* luodaan aluksi taman kok. kooditaulu */
 if ((koodit=(char**)malloc(1000*sizeof(char*)))==NULL)
      error(6);
 size=1000; clkm=0; /* ei yhtaan koodia */

 if ((row=(char*)malloc(LLEN))==NULL) error(6); 

 next=0;
 while (next<n) {
   if (fgets(row, LLEN, f1)==NULL)
     error(5);
	
 if ((seur=strtok(row," "))!=NULL){
   if (seur[strlen(seur)-1]=='\n')
     seur[strlen(seur)-1]='\0';
   code=etsikoodi(koodit,clkm,seur);
   if (code==-1) /* ei loytynyt */
     code=lisaakoodi(&koodit,&clkm,seur,&size);
   if (code!=-1) /* jos lisattiin */
     fprintf(f3,"%d",code); /* tulosta koodattuna */
 }
 while ((seur=strtok(NULL," "))!=NULL){
   if (seur[strlen(seur)-1]=='\n')
     seur[strlen(seur)-1]='\0';
   code=etsikoodi(koodit,clkm,seur);
   if (code==-1) /* ei loytynyt */
     code=lisaakoodi(&koodit,&clkm,seur,&size);
   if (code!=-1) /* jos lisattiin */
   fprintf(f3," %d",code); /* tulosta koodattuna */
 }
 fprintf(f3,"\n");
 next++;
 } /* while */

 /* kirjoita kooditaulu f2:een */
 for (i=0;i<clkm;i++)
   fprintf(f2,"%d %s\n",i,koodit[i]);

}

int etsikoodi(char **t,int clkm,char *seur){
  int i;

  for (i=0;i<clkm;i++)
    if (strcmp(seur,t[i])==0)
      return i;
  return -1; /* ei loytynyt */
}

/* paivittaa clkm:aa ja mahd. sizea */
int lisaakoodi(char ***t,int *clkm,char *seur, int *size){
  int len=strlen(seur)+1;

  /* jos tyhja, ei lisata */
  if (strcmp(seur,"\0")==0)
    return -1;

  /* onko tilaa? jos ei, kasvata */
  if ((*clkm)>=(*size)){
    *t=kasvatataulua(*t,size);
  } 
  if (((*t)[*clkm]=(char*)malloc(len*sizeof(char)))==NULL)
   error(6);

  strcpy((*t)[*clkm],seur);
  (*clkm)++;
  return ((*clkm)-1);
}

/* kasvattaa 2-kert. */
char **kasvatataulua(char **t,int *size){

  if ((t=(char**)realloc(t,2*(*size)*sizeof(char*)))==NULL) 
    error(6);
  (*size)*=2;
  return t;
}

/* kooditaulu valmiina f2:ssa. Lue syotetta f1 ja tulosta muunnettuna */
/* f3:een. */
void muunnanimet(FILE *f1,FILE *f2,FILE *f3){
  char **koodit;
  int clkm=0;
  int n,next,code;
  int LLEN=50000;
  char *seur,*row;

  koodit=luekoodit(f2,&clkm); /* clkm kertoo suurimman koodin numeron, taulussa voi olla tyhjiakin paikkoja */

  /*  for (i=0;i<=clkm;i++)
    if (koodit[i]!=NULL)
    printf("%d %s\n",i,koodit[i]);*/

  n=nofrows(f1); /* syotetiedoston koko */

  if ((row=(char*)malloc(LLEN))==NULL){ 
    error(6);
  } 
  next=0;
  while (next<n) {
    if (fgets(row, LLEN, f1)==NULL){
      printf("muunnanimet (datarivi %d)\n",next+1);
      error(5);
    }
    if ((seur=strtok(row," "))!=NULL){
      if (seur[strlen(seur)-1]=='\n')
	seur[strlen(seur)-1]='\0';
      code=etsikoodi(koodit,clkm+1,seur);
      if (code>-1) 
	fprintf(f3,"%d ",code); /* jos loytyi, tulosta koodattuna */
      /* muuten skipataan */
      /*      else fprintf(f3,"%s",seur); */
    }

    while ((seur=strtok(NULL," "))!=NULL){
      if (seur[strlen(seur)-1]=='\n')
	seur[strlen(seur)-1]='\0';
      code=etsikoodi(koodit,clkm+1,seur);
      if (code>-1) 
	fprintf(f3,"%d ",code); /* jos loytyi, tulosta koodattuna */
      /*else fprintf(f3," %s",seur); */
    }
    fprintf(f3,"\n");
    next++;
  } /* while */


}

/* Muuntaa kaikki kokonaisluku-tokenit ja ~kokonaisluku-tyyppiset. */
void muunnakoodit(FILE *f1,FILE *f2,FILE *f3){
  char **koodit;
  int clkm=0;
  int n,next,v;
  int LLEN=50000;
  char *seur,*row;

  koodit=luekoodit(f2,&clkm); /* clkm kertoo suurimman koodin numeron, taulussa voi olla tyhjiakin paikkoja */
  n=nofrows(f1); /* syotetiedoston koko */

  if ((row=(char*)malloc(LLEN))==NULL) error(6); 
  next=0;
  while (next<n) {
    if (fgets(row, LLEN, f1)==NULL){
      printf("muunnakoodit\n");
      error(5);
    }
    if ((seur=strtok(row," "))!=NULL){
      if (seur[strlen(seur)-1]=='\n')
	seur[strlen(seur)-1]='\0';
      /* jos alussa ~, tulosta se pois */
      if (seur[0]=='~'){ 
	fprintf(f3,"~");
	seur++;
      }
      /* jos kokonaisluku ja maaritetty kooditaulussa, muunna */
      if ((kokluku(seur,&v))&&(v<=clkm)&&(koodit[v]!=NULL))
	fprintf(f3,"%s ",koodit[v]);
      else fprintf(f3,"%s ",seur);
    }

    while ((seur=strtok(NULL," "))!=NULL){
      if (seur[strlen(seur)-1]=='\n')
	seur[strlen(seur)-1]='\0';
      /* jos alussa ~, tulosta se pois */
      if (seur[0]=='~'){ 
	fprintf(f3,"~");
	seur++;
      }
      /* jos kokonaisluku ja maaritetty kooditaulussa, muunna */
      if ((kokluku(seur,&v))&&(v<=clkm)&&(koodit[v]!=NULL))
	fprintf(f3,"%s ",koodit[v]);
      else fprintf(f3,"%s ",seur);
    }

    fprintf(f3,"\n");
    next++;
  } /* while */

}

char **luekoodit(FILE *f,int *clkm){
  int n,next,v,i,len;
  char **koodit;
  char *row,*endp,*tmp;
  int LLEN=1000;
  char *seur;

  n=nofrows(f); /* korkeintaan nain monta koodia */
  (*clkm)=0;

 if ((koodit=(char**)malloc(n*sizeof(char*)))==NULL)
      error(6);
 for (i=0;i<n;i++)
   koodit[i]=NULL;
 if ((row=(char*)malloc(LLEN))==NULL) error(6); 

 next=0;
 while (next<n) {
   if (fgets(row, LLEN, f)==NULL){
     printf("luekoodit\n");
     error(5);
   }
   tmp=row;
   v=strtol(tmp, &endp, 10); 
   if (endp==row){
     printf("Error on line %d\n",next+1);
     error(5);
   }

   if (v>n){
     printf("Suurempi koodi kuin ol!\n");
     /* voisi hoidella kasvattamalla taulukkoa - ei viitsi */
     error(8);
   }

   tmp=endp;
   if (*tmp==' ') /* one separator */
     tmp++;
   
   if ((seur=strtok(tmp," "))!=NULL){
   if (seur[strlen(seur)-1]=='\n')
     seur[strlen(seur)-1]='\0';

   len=strlen(seur)+1;
   if ((koodit[v]=(char*)malloc(len*sizeof(char)))==NULL)
     error(6);
   strcpy(koodit[v],seur);
   if (*clkm<v) (*clkm)=v; /* clkm:aan jaa suurimman koodin numero */
   }
   next++;
 }

 return koodit;
}


/* palauta 1, jos etumerkiton kok.luku, ja arvo v:hen. Muuten pal. 0. */
int kokluku(char *s,int *v){
  int len=strlen(s);
  int i;


  for (i=0;i<len;i++)
    if (isdigit(s[i])==0){
	return 0;
    }

  /* muuten kok.luku */
  (*v)=atoi(s);
  return 1;
}
